echo Script file for generating XML Schema documentation
echo using xs3p schema documentation generator.
echo ""
echo Usage: sh schemaDocumentation.sh pathToXMLConfigurationFile
echo ----------------------------------------------------------------------------------------------
echo Parameters:
echo pathToXMLConfigurationFile  - The path to a configuration file for XML Schema documentation. You can create such a file in the Oxygen "Schema Documentation" dialog. See the Oxygen user manual for additional information on how to create one.
echo ---------------------
echo Example: sh schemaDocumentation.sh samples/personal_schema_doc_config.xml
echo ----------------------------------------------------------------------------------------------

case "$0" in
/*)
  p=$0
;;
*) p=`/bin/pwd`/$0
;;
esac
p=`dirname "$p"`


CP=$p:$p/classes:$p/lib/oxygen.jar:$p/lib/xercesImpl.jar:$p/lib/saxon9.jar:$p/lib/log4j.jar:$p/lib/resolver.jar:$p/lib/jimi.zip

# generates diagrams
java -cp "$CP" -Djava.awt.headless=true ro.sync.exml.XMLSchemaConsoleDocGenerator "$@"
 
RETCODE=$?
if [ "$RETCODE" -ne "0" ]; then
echo "Images generation did not succeed, return code "$RETCODE
exit 1
fi